#include<stdio.h>
#include<string.h>
#include<stdlib.h>

/*
 * Dynaaminen muistinvaraus on mahdollista C-kielell; sit varten
 * kytetn kutsua malloc() eli "memory allocation" tjsp.
 * Kyttjrjestelm varaa tllin pyynnst muistia prosessille, ja
 * palauttaa muistiosoitteen varatun alueen ensimmiseen tavuun.
 *
 * Osoittimista ei pidet kirjaa automaattisesti, vaan kaikki on
 * jlleen kerran sovellusohjelmoijan vastuulla. Varattu alue pit
 * muistaa vapauttaa kutsumalla free() jolle on annettava parametrina
 * nimenomaan sama osoite, jonka malloc() antoi varauksen yhteydess.
 * Jos unohtaa kutsua free() tai jos hukkaa tiedon varatuista
 * muistiosoitteista, tapahtuu ns. "muistivuoto"; varattu tila j
 * vapauttamatta ja kyttjrjestelmn resursseja kulutetaan
 * tarpeettomasti, mahdollisesti mys aina enenevss mrin niin
 * kauan kuin viallinen ohjelma toimii.
 */

/* Tss tehdn uusi merkkijono, joka on yhdistelm kahdesta
 * aiemmasta.
 */
char* mjono_katenoi(const char jonoA[], const char jonoB[]){
  char *jonoC, *p;
  int pitA, pitB, pitC, i;

  pitA = strlen(jonoA);
  pitB = strlen(jonoB);
  pitC = pitA + pitB + 1;
  
  p = jonoC = (char*) malloc(pitC);

  for(i=0;i<pitA;i++){
    *p = jonoA[i];
    p++;
  }
  for(i=0;i<pitB;i++){
    *p = jonoB[i];
    p++;
  }
  *p = '\0';

  return jonoC;
}


int main(int argc, char *argv[]){
  char a[] = "Saippua";
  char b[] = "kauppias";
  char *c;
  int i, j;

  /* Tmhn nyt nytt tutulta Javasta, jossa String-merkkijonoja voisi
   *  yhdist luoden samalla uuden jonon: 
   */
  c = mjono_katenoi(a,b);
   
  printf("Alkuperiset jonot: '%s' ja '%s'.\n", a, b);
  printf("Yhdistetty jono: '%s'\n", c);

  c = mjono_katenoi(b,c);
  printf("Uusi yhdistetty jono: '%s'\n", c);

  c = mjono_katenoi(c,b);
  printf("Uusi yhdistetty jono: '%s'\n", c);

  c = mjono_katenoi(c,c);
  printf("Uusi yhdistetty jono: '%s'\n", c);


  printf("Jatkanpa tst yhdistelemist...\n");
  
  for(j=0; j<100; j++){
    for(i=0; i<1000; i++){
      c = mjono_katenoi(c,"s");
    }
    printf("Jononi pituus on nyt %d merkki\n", strlen(c));
    sleep(1);
  }
  

  return 0;
}
